import flash.display.Sprite;
import flash.events.MouseEvent;
import flash.events.Event;
import flash.text.TextField;
import flash.text.TextFieldAutoSize;
import flash.text.TextFormat;
import flash.text.AntiAliasType;
import flash.text.CSMSettings;
import flash.text.TextRenderer;
import flash.text.TextColorType;
import flash.text.FontStyle;
import flash.text.FontType;

class ExampleAdvancedText extends Sprite {
  public function new() {
    super();
    var format:TextFormat = new TextFormat();
    format.color = 0x336699;
    format.size = 48;		// フォントサイズ
    format.font = "myFont";	// フォント名
    var myText:TextField = new TextField();
    myText.embedFonts = true;	// 埋め込みフォント
    myText.autoSize = TextFieldAutoSize.LEFT;
    myText.antiAliasType = AntiAliasType.ADVANCED; // TextRendererを使用する場合
    myText.defaultTextFormat = format;
    myText.selectable = false;
    myText.mouseEnabled = true;
    myText.text = "Hello World?";
    addChild(myText);
    myText.addEventListener(MouseEvent.CLICK, clickHandler);
  }
  function clickHandler(event:Event):Void {
    var myAntiAliasSettings:CSMSettings = new CSMSettings(
      48,	// fontSize:		ターゲットとなるフォントサイズ
      2,	// insideCutoff:	これを大きくすると細く滑らかになる
      -0	// outsideCutoff:	これを大きくすると太く滑らかになる
    );
    var myAliasTable:Array<CSMSettings> = [myAntiAliasSettings];
    TextRenderer.setAdvancedAntiAliasingTable(
      "myFont", FontStyle.REGULAR,	// ターゲットとなるフォント名とスタイル
      TextColorType.DARK_COLOR,		// 線が濃い(DARK_COLOR)か、薄い(LIGHT_COLOR)か
      myAliasTable			// 所望の CSMSettings
    );
  }
  static function main() {
    var me = new ExampleAdvancedText();
    flash.Lib.current.addChild(me);
  }
}
