import flash.display.MovieClip;
import flash.display.Shape;
import flash.display.Sprite;
import flash.text.TextField;
import flash.events.MouseEvent;
import flash.events.Event;

private class Ball extends MovieClip {
  var d:Float;
  public function new(color:Int, label:String) {
    super();
    graphics.lineStyle(1, 0x000000, 100);
    graphics.beginFill(color, 100);
    graphics.drawCircle(x, y, 30);
    graphics.endFill();
    var myTextField:TextField = new TextField();
    myTextField.text = label;
    addChild(myTextField);
    d = -0.05;
    addEventListener(Event.ENTER_FRAME, animate);
  }
  public function animate(ev:Event):Void {
    alpha += d;
    if (alpha < 0) { d = 0.05; }
    else if (alpha > 1) { d = -0.05; }
  }
}

class ExampleAnimation extends Sprite {
  var ball_A:Ball;
  var ball_B:Ball;
  var ball_C:Ball;

  public function new() {
    super();
    ball_A = new Ball(0xFFCC00, "a");
    ball_A.name = "ball_A";
    ball_A.x = 20;
    ball_A.y = 20;
    addChild(ball_A);
    ball_B = new Ball(0x00FFCC, "b");
    ball_B.name = "ball_B";
    ball_B.x = 70;
    ball_B.y = 20;
    addChild(ball_B);
    ball_C = new Ball(0xCC00FF, "c");
    ball_C.name = "ball_C";
    ball_C.x = 40;
    ball_C.y = 60;
    addChildAt(ball_C, 1);
    addEventListener(MouseEvent.MOUSE_DOWN, onPress);
    addEventListener(MouseEvent.MOUSE_UP, onRelease);
    x = y = 20;
  }
  public function onPress(ev:MouseEvent):Void { removeChild(ball_C); startDrag(false); }
  public function onRelease(ev:MouseEvent):Void { stopDrag(); addChild(ball_C); }
  static function main() {
    var me = new ExampleAnimation();
    flash.Lib.current.addChild(me);
  }
}
