import flash.display.DisplayObject;
import flash.display.StageAlign;
import flash.display.StageDisplayState;
import flash.display.StageScaleMode;
import flash.events.FullScreenEvent;
import flash.display.Sprite;
//import flash.events.AsyncErrorEvent;
import flash.events.MouseEvent;
import flash.events.NetStatusEvent;
import flash.events.TimerEvent;
import flash.text.TextField;
import flash.text.TextFieldAutoSize;
import flash.text.TextFieldType;
import flash.text.TextFormat;
import flash.media.Video;
import flash.net.NetConnection;
import flash.net.NetStream;
import flash.utils.Timer;
import flash.display.SimpleButton;

class Label extends Sprite {
  public var tf:TextField;
  public var bg:Sprite;
  var type:Int;
  var state:Int;
  var size:Array<Float>;

  public function new(label:String, ?tfm:TextFormat, ?type:Int, ?state:Int, ?size:Array<Float>) {
    super();
    tf = new TextField();
    if (tfm != null)
      tf.defaultTextFormat = tfm;
    this.type = type;
    this.state = state;
    if (size != null) {
      this.size = size;
      tf.width = size[0] + 2*2;
      tf.height = size[1] + 2*2;
    }
    else
      tf.autoSize = TextFieldAutoSize.LEFT;
    tf.htmlText = label;
    switch (type) {
      case 1: {
        tf.type = TextFieldType.INPUT;
      }
    }
    tf.embedFonts = switch (tfm.font) {
    case "Webdings", "Wingdings", "Wingdings 2", "Wingdings 3": true;
    default: false;
    }
    bg = new Sprite();
    bgDraw();
    addChild(bg);
    addChild(tf);
  }
  public function bgDraw() {
    var m:Float = tf.defaultTextFormat.leftMargin + tf.defaultTextFormat.rightMargin;
    var d:Float = switch (state) { case 2,3: 2.0; default: 4.0; };
    var size:Array<Float> = (this.size != null) ? this.size : [tf.textWidth, tf.textHeight];

    x = y = 4 - d;
    bg.graphics.clear();
    switch (type) {
      case 0: {
        var w:Float = switch (state) { case 1: 2.0; default: 1.0; };
        bg.graphics.lineStyle(0, 0xCCCCCC);
        bg.graphics.beginFill(0xCCCCCC);
        bg.graphics.drawRoundRect(d, d, size[0] + m + 2*2, size[1] + 2*2, 2*4);
        bg.graphics.lineStyle(w, 0xFFFFFF);
        bg.graphics.beginFill(0xFFFFFF);
        bg.graphics.drawRoundRect(0, 0, size[0] + m + 2*2, size[1] + 2*2, 2*4);
        bg.graphics.endFill();
      }
      case 1: {
        var w:Float = switch (state) { case 1: 2.0; default: 1.0; };
        bg.graphics.lineStyle(0, 0xCCCCCC);
        bg.graphics.beginFill(0xCCCCCC);
        bg.graphics.drawRect(d, d, size[0] + m + 2*2, size[1] + 2*2);
        bg.graphics.lineStyle(w, 0x000000);
        bg.graphics.beginFill(0xFFFFFF);
        bg.graphics.drawRect(0, 0, size[0] + m + 2*2, size[1] + 2*2);
        bg.graphics.endFill();
      }
      default: {
        var w:Float = switch (state) { case 1: 4.0; default: 2.0; };
        bg.graphics.lineStyle(0, 0xCCCCCC);
        bg.graphics.beginFill(0xCCCCCC);
        bg.graphics.drawRoundRect(d, d, size[0] + m + 2*2, size[1] + 2*2, 2*4);
        bg.graphics.lineStyle(w, 0x000000);
        bg.graphics.beginFill(0xFFFFFF);
        bg.graphics.drawRoundRect(0, 0, size[0] + m + 2*2, size[1] + 2*2, 2*4);
        bg.graphics.endFill();
      }
    }
  }
  public function setLabel(label:String) {
    tf.htmlText = label;
    bgDraw();
  }
}

class NetStreamClient {
  public var duration:Float;

  public function new() {}
  public function onMetaData(info:Dynamic) {
    duration = info.duration;
  }
}

class ExampleURLVideo extends Sprite {
  var start:Bool;
  var pause:Bool;
  var scale:Float;
  var nc:NetConnection;
  var ns:NetStream;
  var tm:Timer;
  var items:Array<Dynamic>;
  var fs:Array<TextFormat>;

  public function new() {
    super();
    var s:Float = 16.0;
    fs = [
      new TextFormat("Courier", s, 0x000000),
      new TextFormat("Webdings", s, 0x000000),
    ];
    items = [
      new SimpleButton(),
      new SimpleButton(new Label("\x37", fs[1], 2, 0),
                       new Label("\x37", fs[1], 2, 1),
                       new Label("\x37", fs[1], 2, 2),
                       new Label("\x37", fs[1], 2)),
      new SimpleButton(new Label("\x38", fs[1], 2, 0),
                       new Label("\x38", fs[1], 2, 1),
                       new Label("\x38", fs[1], 2, 2),
                       new Label("\x38", fs[1], 2)),
      new Label("URL",	fs[0], 0, 0, [s*2, s]),
      new Label("",	fs[0], 1, 0, [s*24, s]),
      new SimpleButton(),
      new SimpleButton(new Label("\x4c", fs[1], 2, 0),
                       new Label("\x4c", fs[1], 2, 1),
                       new Label("\x4c", fs[1], 2, 2),
                       new Label("\x4c", fs[1], 2)),
      new SimpleButton(new Label("\x31", fs[1], 2, 0),
                       new Label("\x31", fs[1], 2, 1),
                       new Label("\x31", fs[1], 2, 2),
                       new Label("\x31", fs[1], 2)),
      new Video(),
      new TextField(),
    ];
    start = pause = false;
    scale = 1;
    transition_pause();
    transition_start();
    transition();
    items[0].addEventListener(MouseEvent.CLICK, pbPause);
    items[1].addEventListener(MouseEvent.CLICK, pbRew);
    items[2].addEventListener(MouseEvent.CLICK, pbFF);
    items[5].addEventListener(MouseEvent.CLICK, pbStart);
    items[6].addEventListener(MouseEvent.CLICK, pbScaleVideo);
    items[7].addEventListener(MouseEvent.CLICK, pbFullScreen);
    items[9].autoSize = TextFieldAutoSize.LEFT;
    items[0].x = items[0].y = 4;
    layouts(0, [items[0], items[1], items[2], items[3], items[4], items[5], items[6], items[7]]);
    layouts(1, [items[0], items[8], items[9]]);
    for (i in 0...items.length)
      addChild(items[i]);
    nc = new NetConnection();
    nc.connect(null);
    ns = new NetStream(nc);
    //ns.addEventListener(AsyncErrorEvent.ASYNC_ERROR, asyncErrorHandler);
    ns.addEventListener(NetStatusEvent.NET_STATUS, statusHandler);
    ns.client = new NetStreamClient();
    items[8].attachNetStream(ns);
    items[8].smoothing = true;
    tm = new Timer(1000, 0);
    tm.addEventListener(TimerEvent.TIMER, timerHandler);
    flash.Lib.current.stage.align = StageAlign.TOP_LEFT;
    flash.Lib.current.stage.scaleMode = StageScaleMode.NO_SCALE;
  }
  function layouts(type:Int, items:Array<Dynamic>) {
    var i:Int;

    switch (type) {
    case 0:
      for (i in 1...items.length) {
        items[i].x = items[i-1].x + items[i-1].getRect(this).width + 4;
        items[i].y = items[i-1].y;
      }
    case 1:
      for (i in 1...items.length) {
        items[i].x = items[i-1].x;
        items[i].y = items[i-1].y + items[i-1].getRect(this).height + 4;
      }
    }
  }
  function transition_pause() {
    items[0].upState      = new Label(pause?"\x34":"\x3b", fs[1], 2, 0);
    items[0].overState    = new Label(pause?"\x34":"\x3b", fs[1], 2, 1);
    items[0].downState    = new Label(pause?"\x34":"\x3b", fs[1], 2, 2);
    items[0].hitTestState = new Label(pause?"\x34":"\x3b", fs[1], 2);
  }
  function transition_start() {
    items[5].upState      = new Label(start?"\xb7":"\xb8", fs[1], 2, 0);
    items[5].overState    = new Label(start?"\xb7":"\xb8", fs[1], 2, 1);
    items[5].downState    = new Label(start?"\xb7":"\xb8", fs[1], 2, 2);
    items[5].hitTestState = new Label(start?"\xb7":"\xb8", fs[1], 2);
  }
  function transition() {
    items[9].text = "";
    if (ns != null) {
      items[9].text += "bytes: " + ns.bytesLoaded + "/" + ns.bytesTotal + "\n";
      items[9].text += "time: " + ns.time + "/" + ns.client.duration + "\n";
      if (items[8].videoWidth!=0 && items[8].videoHeight!=0 &&
          (items[8].width != items[8].videoWidth*scale ||
           items[8].height != items[8].videoHeight*scale)) {
        items[8].width = items[8].videoWidth*scale;
        items[8].height = items[8].videoHeight*scale;
        layouts(1, [items[0], items[8], items[9]]);
      }
    }
  }
  public function statusHandler(event:NetStatusEvent) {
    switch (event.info.code) {
    case "NetStream.Buffer.Full":
    case "NetStream.Buffer.Empty":
      {}
    default:
      items[9].text += event.info.code + "\n";
    }
  }
  public function timerHandler(event:TimerEvent) {
    transition();
  }
  public function pbStart(event:MouseEvent) {
    if (!start) {
      if (items[4].tf.text != null) {
        ns.play(items[4].tf.text);
        start = true;
        tm.start();
        transition_start();
      }
    }
    else {
      ns.close();
      start = pause = false;
      tm.stop();
      transition_start();
      transition_pause();
    }
    transition();
  }
  public function pbPause(event:MouseEvent) {
    if (start) {
      ns.togglePause();
      pause = !pause;
      transition_pause();
    }
  }
  public function pbRew(event:MouseEvent) {
    if (start)
      ns.seek((ns.time>=10)?ns.time-10:0);
  }
  public function pbFF(event:MouseEvent) {
    if (start)
      ns.seek(ns.time+10);
  }
  public function pbScaleVideo(event:MouseEvent) {
    scale = if (scale == .5) 1;
    else if (scale == 1) 1.5;
    else if (scale == 1.5) 2;
    else if (scale == 2)
      Math.min((stage.stageWidth-(items[8].x+4))/items[8].videoWidth,
	       (stage.stageHeight-(items[8].y+4))/items[8].videoHeight);
    else .5;
    transition();
  }
  public function pbFullScreen(event:MouseEvent) {
    stage.displayState = (stage.displayState==StageDisplayState.FULL_SCREEN)?
      StageDisplayState.NORMAL:StageDisplayState.FULL_SCREEN;
    scale = (stage.displayState==StageDisplayState.FULL_SCREEN)?2:.5;
    pbScaleVideo(event);
  }
  static function main() {
    var me = new ExampleURLVideo();
    flash.Lib.current.addChild(me);
  }
}
